﻿/*---------------------------------------------------------------------------*
  Project:  Horizon
  File:     demo_TextsRenderData.h

  Copyright (C)2009-2013 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 50863 $
 *---------------------------------------------------------------------------*/

#ifndef DEMO_TEXTS_RENDER_DATA_H_
#define DEMO_TEXTS_RENDER_DATA_H_

#include "demo/RenderData/demo_TrianglesRenderData.h"

namespace demo
{ 
    
    /* Please see man pages for details 
    
    
    
    */
    const f32 FONT_OFFSET_S = 0.125f;    

    /* Please see man pages for details 
    
    
    
    */
    const f32 FONT_OFFSET_T = 0.0625f;
    
    /* Please see man pages for details 
    

    
    */
    const u32 FONT_BASE_SIZE = 8;

    /* Please see man pages for details 
    

    
    */
    const u32 MAX_CHAR_LENGTH_PER_LINE = 256;

    /* Please see man pages for details 
    

    
    */
    const u32 MAX_TEXT_LENGTH = MAX_TRIANGLES_NUM / 2;

    /* Please see man pages for details 
        

        
    */

    class TextsRenderData : public demo::TrianglesRenderData
    {
    public:
        /* Please see man pages for details 
        

        
        */
        TextsRenderData(void);

        /* Please see man pages for details 
        

        
        */
        virtual ~TextsRenderData(void);
    
   public:
        /* Please see man pages for details 
        

        
        */
        virtual void Initialize(void);

        /* Please see man pages for details 
        

        
        */
        virtual void Finalize(void);

    public:
        /* Please see man pages for details 
        

        
                
        
        
        */
        void InitializeVertexBuffers(const u32 vertexAttributes, const GLenum triangleType, const u32 maxTextLength);
    protected:
        void SetMaxTextLength(const u32 maxTextLength);
    
    public:
        /* Please see man pages for details 
        

        
        
        
        
        
        
        
        */
        void AddText(const f32 windowCoordinateX, const f32 windowCoordinateY,
            const char* text, const u32 textLength, const f32 normalizedDeviceCoordinateZ);

    public:
        /* Please see man pages for details 
        

        
        */
        void ClearPackedTextLength(void);
    protected:
        void SetPackedTextLength(const u32 packedTextLength);
    public:
        /* Please see man pages for details 
        

        
        */
        u32 GetPackedTextLength(void) const;
    
    public:
        /* Please see man pages for details 
        

        
       
        
        */
        void SetFontSize(const f32 fontSize);

        /* Please see man pages for details 
        

        
                
        
        
        
        
        */
        void SetFontColor(const f32 red, const f32 green,
            const f32 blue, const f32 alpha);

    protected:
        u32 m_PackedTextLength;
        u32 m_MaxTextLength;

        f32 m_FontSize;
        f32 m_Color[4];

    protected:    
        u32 m_FontBaseSize;
        f32 m_FontOffsetS;
        f32 m_FontOffsetT;        
    };

}

#endif
