/*-----------------------------------------------------------------------------
  Project:  QRE
  File:     Graphicscontrol.h

  Copyright (C)2010 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Revision: 1.6 $
 *----------------------------------------------------------------------------*/
#ifndef GRAPHICSCONTROL_H_
# define GRAPHICSCONTROL_H_

# include <nn/gx.h>
# include <demo.h>

class GraphicsControl
{
private:
    nn::fnd::ExpHeap *s_AppHeap;
    demo::RenderSystemDrawing s_RenderSystem;
    uptr s_HeapForGx;

public:
    GraphicsControl();
    ~GraphicsControl();

    int InitializeGraphics(nn::fnd::ExpHeap *heap);
    void FinalizeGraphics(void);
    void ClearDisplay(const s32 display);
    void SwapBuffer(const s32 display = NN_GX_DISPLAY_BOTH, const bool wait = true);
    void DrawImage(u8* textureDataPtr, u32 width, u32 height);

private:
    u8 *GetTextureDataFromRawData(const u32& width, const u32& height,
                                  u8* rawDataBuffer,
                                  u32& textureWidth, u32& textureHeight);
    u32 GetTextureLength(const u32 &imageLength);
};

#endif // GRAPHICSCONTROL_H_
